<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class ParamLeitContPessoasFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function insertParamLeituras($params) {
        try {
        $sql = "INSERT INTO FCM_PARAMLEITCONTPESSOAS (
            NRPARAMLEITCONTPESSOAS,
            CDCLIENTE,
            NRLOCALCLIENTE,
            IDTIPOSENSOR,
            IDMACDEVICE, 
            IDSENSOR, 
            NRQTPESSOASALERT, 
            VRDISTANCIAMINLEIT,
            VRDISTANCIAMAXLEIT,
            VRDISTANCIAMEDLEIT, 
            QTMATRIZLEITURA,
            QTTEMPRECONHECIMENTO, 
            IDMODODISTANCIA,
            QTTEMPOREPETLEIT,
            HRINICIODIA, 
            HRFINALDIA,
            NRORG,
            IDATIVO,
            DTINCLUSAO)
         VALUES (
            :NRPARAMLEITCONTPESSOAS,
            :CDCLIENTE,
            :NRLOCALCLIENTE,
            :IDTIPOSENSOR,
            :IDMACDEVICE, 
            :IDSENSOR, 
            :NRQTPESSOASALERT, 
            :VRDISTANCIAMINLEIT,
            :VRDISTANCIAMAXLEIT,
            :VRDISTANCIAMEDLEIT, 
            :QTMATRIZLEITURA,
            :QTTEMPRECONHECIMENTO, 
            :IDMODODISTANCIA,
            :QTTEMPOREPETLEIT,
            :HRINICIODIA, 
            :HRFINALDIA,
            :NRORG,
            'S',
            SYSDATE)";
            $std = $this->connection->prepare($sql);
            // var_dump($params);
            // die;
            $std->execute($params);
            $message = "Item was sucessfuly inserted.";
            return $message;
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function getParamLeituras($params) {
        $useParams = false;
        
        $sqlCode = "SELECT 
            plcp.NRPARAMLEITCONTPESSOAS,
            plcp.CDCLIENTE,
            plcp.NRLOCALCLIENTE,
            plcp.IDTIPOSENSOR,
            plcp.IDMACDEVICE, 
            plcp.IDSENSOR, 
            plcp.NRQTPESSOASALERT, 
            plcp.VRDISTANCIAMINLEIT,
            plcp.VRDISTANCIAMAXLEIT,
            plcp.VRDISTANCIAMEDLEIT, 
            plcp.QTMATRIZLEITURA,
            plcp.QTTEMPRECONHECIMENTO, 
            plcp.IDMODODISTANCIA,
            plcp.QTTEMPOREPETLEIT,
            plcp.HRINICIODIA, 
            plcp.HRFINALDIA, 
            plcp.QTLEITTOTALDIA,
            plcp.NRORG,
            plcp.IDATIVO,
            plcp.DTINCLUSAO
            FROM FCM_PARAMLEITCONTPESSOAS plcp";
            
        $whereClausule = $this->concatWhereClausule($params);
        if (strlen($whereClausule) > 0) {
            $useParams = true;
            $sqlCode .= $whereClausule;
        }
        $std = $this->connection->prepare($sqlCode);
        if ($useParams) {
            $std->execute($params);   
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }
    
    public function updateParamLeituras($params) {
        try {
        $sql = "UPDATE FCM_PARAMLEITCONTPESSOAS 
                    SET
                        CDCLIENTE = :CDCLIENTE,
                        NRLOCALCLIENTE = :NRLOCALCLIENTE,
                        IDTIPOSENSOR = :IDTIPOSENSOR,
                        IDMACDEVICE = :IDMACDEVICE, 
                        IDSENSOR = :IDSENSOR, 
                        NRQTPESSOASALERT = :NRQTPESSOASALERT, 
                        VRDISTANCIAMINLEIT = :VRDISTANCIAMINLEIT,
                        VRDISTANCIAMAXLEIT = :VRDISTANCIAMAXLEIT,
                        VRDISTANCIAMEDLEIT = :VRDISTANCIAMEDLEIT, 
                        QTMATRIZLEITURA = :QTMATRIZLEITURA,
                        QTTEMPRECONHECIMENTO = :QTTEMPRECONHECIMENTO, 
                        IDMODODISTANCIA = :IDMODODISTANCIA,
                        QTTEMPOREPETLEIT = :QTTEMPOREPETLEIT,
                        HRINICIODIA = :HRINICIODIA, 
                        HRFINALDIA = :HRFINALDIA,
                        DTULTATU = SYSDATE
                 WHERE NRPARAMLEITCONTPESSOAS = :NRPARAMLEITCONTPESSOAS";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $message = "Editado com sucesso";
            return $message;
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }
    
    private function concatWhereClausule($params) {
        $useParams = false;
        $paramKeys = array_keys($params);
        $query = "";
        foreach($paramKeys as $key) {
            if (!$useParams) {
                $useParams = true;
                $query.= " WHERE ";
            } else {
                $query.= " AND ";
            }
            $query.= 'plcp' . "." . $key . " = :" . $key;
        }
        return $query;
    }
}

?>